from miniprojectutils import *


# 1pt
def rgb_to_grey(r: int, g: int, b: int) -> int:
    """Convert an RGB color to a greyscale value."""
    return ...  # TODO


# 2pt
def to_grayscale(img: Image) -> Image:
    """Convert the given image to grayscale."""
    print("   Converting to grayscale...")
    return ...  # TODO


# 1pt
def clamp_index(index: int, length: int) -> int:
    """Return the index, clamped to the range [0, length-1]."""
    return ...  # TODO


# 3pt
def apply_kernel(img_grey: Image, kernel: Kernel) -> Image:
    """Apply a kernel to an image."""
    return ...  # TODO


def smoothen(img_grey: Image) -> Image:
    """Smooth the image using a 3x3 kernel."""
    print("   Smoothening image...")
    # fmt: off
    kernel_smooth = (np.array([
        [1, 1, 1],
        [1, 2, 1],
        [1, 1, 1],
    ]) / 10)
    # fmt: on
    return apply_kernel(img_grey, kernel_smooth)


def sobel(img_grey: Image) -> Image:
    """Apply the Sobel filter to the image."""
    print("   Sobel...")
    # fmt: off
    kernel_sobel_x = np.array([
        [-1, 0, 1],
        [-2, 0, 2],
        [-1, 0, 1],
    ])
    kernel_sobel_y = np.array([
        [-1, -2, -1],
        [ 0,  0,  0],
        [ 1,  2,  1],
    ])
    # fmt: on
    sobel_x = apply_kernel(img_grey, kernel_sobel_x)
    sobel_y = apply_kernel(img_grey, kernel_sobel_y)
    result = np.sqrt(sobel_x * sobel_x + sobel_y * sobel_y)
    truncated_result = np.minimum(255, result)
    return truncated_result


# 2pts
def find_seam__init_pixel_data(img_grey: Image) -> list[list[PixelData]]:
    """Initialize the grid of PixelData and fill the first row. Called in find_seam()."""
    return ...


# 3pts
def find_seam__fill_pixel_data(cells: list[list[PixelData]], img_grey: Image) -> None:
    """Fill the rest of the grid by finding the minimum energy for each pixel row by row. Called in find_seam()."""
    ...


# 1pt
def find_seam__find_min_column_on_last_row(cells: list[list[PixelData]]) -> int:
    """Find the column with the minimum energy on the last row."""
    return ...


# 2pt
def find_seam__backtrack_seam(cells: list[list[PixelData]], min_col: int) -> Seam:
    """Backtrack the seam (as a list of column numbers) from the last row to the first row."""
    return ...


def find_seam(img_grey: Image) -> Seam:
    """Find the seam with the lowest energy."""
    print("   Finding seam...")

    # 5.1 Initialize the grid of empty PixelData and fill the first row
    cells: list[list[PixelData]] = find_seam__init_pixel_data(img_grey)

    # 5.2 Fill the rest of the grid
    find_seam__fill_pixel_data(cells, img_grey)

    # 5.3 Find the minimum energy on the last row
    min_col = find_seam__find_min_column_on_last_row(cells)
    print(f"   Min energy at col {min_col} is {cells[-1][min_col].min_energy}")

    # 5.4 Backtrack the seam
    seam = find_seam__backtrack_seam(cells, min_col)
    return seam


def seam_carving(img_path: str, num_cols: int) -> None:
    print(f"---- Seam carving on {img_path} with {num_cols} columns ----")

    # 0. Make folders for the results
    name, ext = split_name_ext(img_path)
    output_folder = name + os.path.sep
    highlight_folder = output_folder + "4_highlights" + os.path.sep
    highlights_grey_folder = output_folder + "4_highlights_grey" + os.path.sep
    steps_folder = output_folder + "5_steps" + os.path.sep
    for folder in output_folder, highlight_folder, highlights_grey_folder, steps_folder:
        os.makedirs(folder, exist_ok=True)

    # 1. Load the source image
    img = load_image(img_path)

    # 2. Convert to grayscale
    # img_grey = to_grayscale(img)
    # save_image(img_grey, output_folder + "1_grey" + ext)

    # 3. Smoothen
    # img_grey = smoothen(img_grey)
    # save_image(img_grey, output_folder + "2_smooth" + ext)

    # 4. sobels
    # img_grey = sobel(img_grey)
    # save_image(img_grey, output_folder + "3_sobel" + ext)

    for i in range(num_cols):
        # 5. Find seam
        # seam = find_seam(img_grey)

        # 6. Highlight seam
        # img_highlight = highlight_seam(img, seam)
        # save_image(img_highlight, highlight_folder + f"highlight_{i}" + ext)
        # img_grey_highlight = highlight_seam(img_grey, seam)
        # save_image(img_grey_highlight, highlights_grey_folder + f"highlight_{i}_grey" + ext)

        # 7. remove seam from both the color and the grayscale image
        # img = remove_seam(img, seam)
        # save_image(img, steps_folder + f"step_{i}" + ext)
        # img_grey = remove_seam(img_grey, seam)

        pass


if __name__ == "__main__":

    # Insérez du code de test ici si vous le souhaitez

    # Ceci lance l'opération sur cette image en enlevant le nomre de colonnes spécifié
    seam_carving("imgs/americascup.jpg", num_cols=10)
